﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ZXing.QrCode;

namespace qrcode
{
	public partial class generatefile : System.Web.UI.Page
	{
		protected void Page_Load(object sender, EventArgs e)
		{

		}

		protected void submitButton_Click(object sender, EventArgs e)
		{
			Byte[] byteArray;
			var width = 250; // width of the Qr Code   
			var height = 250; // height of the Qr Code   
			var margin = 0;
			var qrCodeWriter = new ZXing.BarcodeWriterPixelData
			{
				Format = ZXing.BarcodeFormat.QR_CODE,
				Options = new QrCodeEncodingOptions
				{
					Height = height,
					Width = width,
					Margin = margin
				}
			};
			var pixelData = qrCodeWriter.Write(qrTextBox.Text);

			// creating a bitmap from the raw pixel data; if only black and white colors are used it makes no difference   
			// that the pixel data ist BGRA oriented and the bitmap is initialized with RGB   
			using (var bitmap = new System.Drawing.Bitmap(pixelData.Width, pixelData.Height, System.Drawing.Imaging.PixelFormat.Format32bppRgb))
			{
				using (var ms = new MemoryStream())
				{
					var bitmapData = bitmap.LockBits(new System.Drawing.Rectangle(0, 0, pixelData.Width, pixelData.Height), System.Drawing.Imaging.ImageLockMode.WriteOnly, System.Drawing.Imaging.PixelFormat.Format32bppRgb);
					try
					{
						// we assume that the row stride of the bitmap is aligned to 4 byte multiplied by the width of the image   
						System.Runtime.InteropServices.Marshal.Copy(pixelData.Pixels, 0, bitmapData.Scan0, pixelData.Pixels.Length);
					}
					finally
					{
						bitmap.UnlockBits(bitmapData);
					}

					// save to folder
					string fileGuid = Guid.NewGuid().ToString().Substring(0, 4);
					bitmap.Save(Server.MapPath("~/qrr") + "/file-" + fileGuid + ".png", System.Drawing.Imaging.ImageFormat.Png);

					// save to stream as PNG   
					bitmap.Save(ms, System.Drawing.Imaging.ImageFormat.Png);
					byteArray = ms.ToArray();
				}
			}

			qrCodeDiv.Style.Add("display", "block");
			qrCodeImage.ImageUrl = String.Format("data:image/png;base64,{0}", Convert.ToBase64String(byteArray));
		}
	}
}